﻿using System;
using System.Runtime.InteropServices;
using System.Windows;

namespace SpotnetWatchdog.Utils
{
    /// <summary>
    /// Source: http://www.codeproject.com/KB/cs/SingleInstanceAppMutex.aspx
    /// </summary>
    static class WinApi
    {
        [DllImport("user32")]
        public static extern int RegisterWindowMessage(string message);

        public static int RegisterWindowMessage(string format, params object[] args)
        {
            string message = String.Format(format, args);
            return RegisterWindowMessage(message);
        }

        public const int HWND_BROADCAST = 0xffff;
        private const int SW_SHOWNORMAL = 1;
        private const int SW_SHOWMAXIMIZED = 3;

        [DllImport("user32")]
        public static extern bool PostMessage(IntPtr hwnd, int msg, IntPtr wparam, IntPtr lparam);

        [DllImportAttribute("user32.dll")]
        public static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

        [DllImportAttribute("user32.dll")]
        public static extern bool SetForegroundWindow(IntPtr hWnd);

        public static void ShowToFront(IntPtr window, WindowState windowState)
        {
            int nCmdShow = (windowState == WindowState.Maximized ? SW_SHOWMAXIMIZED : SW_SHOWNORMAL);
            
            ShowWindow(window, nCmdShow);
            SetForegroundWindow(window);
        }
    }
}
